<?php

declare(strict_types=1);

namespace Drupal\Tests\ui_patterns_settings\Kernel\Source;

use Drupal\Tests\media\Traits\MediaTypeCreationTrait;
use Drupal\Tests\ui_patterns_settings\Kernel\UiPSSourcePluginsTestBase;

/**
 * Test MediaSource.
 *
 * @coversDefaultClass \Drupal\ui_patterns_settings\Plugin\UiPatterns\Source\MediaSource
 * @group ui_patterns_settings
 */
class MediaSourceTest extends UiPSSourcePluginsTestBase {
  use MediaTypeCreationTrait;

  /**
   * {@inheritdoc}
   */
  protected $strictConfigSchema = FALSE;

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    parent::setUp();
    $this->installEntitySchema('file');
    $this->installEntitySchema('media');
    $this->createMediaType('image');
    $this->installConfig(['file', 'image', 'media']);
  }

  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'ui_patterns_settings',
    'image',
    'file',
    'media',
    'media_test_source',
    'options',
    'link',
  ];

  /**
   * Test TokenSource Plugin.
   */
  public function testPlugin(): void {
    $this->runSourcePluginTests('media_', __DIR__ . "/../../fixtures/TestDataSet.yml");
  }

}
